Index: uspace/drv/uhci-hcd/iface.c
===================================================================
--- uspace/drv/uhci-hcd/iface.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/uhci-hcd/iface.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -41,42 +41,53 @@
 #include "hc.h"
 
-static inline int setup_batch(
-    ddf_fun_t *fun, usb_target_t target, usb_direction_t direction,
-    void *data, size_t size, void * setup_data, size_t setup_size,
-    usbhc_iface_transfer_in_callback_t in,
-    usbhc_iface_transfer_out_callback_t out, void *arg, const char* name,
-    hc_t **hc, usb_transfer_batch_t **batch)
-{
-	assert(hc);
-	assert(batch);
-	assert(fun);
-	*hc = fun_to_hc(fun);
-	assert(*hc);
-
-	size_t res_bw;
-	endpoint_t *ep = usb_endpoint_manager_get_ep(&(*hc)->ep_manager,
-	    target.address, target.endpoint, direction, &res_bw);
-	if (ep == NULL) {
-		usb_log_error("Endpoint(%d:%d) not registered for %s.\n",
-		    target.address, target.endpoint, name);
-		return ENOENT;
-	}
-
-	usb_log_debug("%s %d:%d %zu(%zu).\n",
-	    name, target.address, target.endpoint, size, ep->max_packet_size);
-
-	const size_t bw = bandwidth_count_usb11(
-	    ep->speed, ep->transfer_type, size, ep->max_packet_size);
-	if (res_bw < bw) {
-		usb_log_error("Endpoint(%d:%d) %s needs %zu bw "
-		    "but only %zu is reserved.\n",
-		    target.address, target.endpoint, name, bw, res_bw);
-		return ENOSPC;
-	}
-
-	*batch = batch_get(
-	        fun, ep, data, size, setup_data, setup_size, in, out, arg);
-	if (!*batch)
-		return ENOMEM;
+/** Reserve default address interface function
+ *
+ * @param[in] fun DDF function that was called.
+ * @param[in] speed Speed to associate with the new default address.
+ * @return Error code.
+ */
+static int reserve_default_address(ddf_fun_t *fun, usb_speed_t speed)
+{
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_log_debug("Default address request with speed %d.\n", speed);
+	usb_device_keeper_reserve_default_address(&hc->manager, speed);
+	return EOK;
+#if 0
+	endpoint_t *ep = malloc(sizeof(endpoint_t));
+	if (ep == NULL)
+		return ENOMEM;
+	const size_t max_packet_size = speed == USB_SPEED_LOW ? 8 : 64;
+	endpoint_init(ep, USB_TRANSFER_CONTROL, speed, max_packet_size);
+	int ret;
+try_retgister:
+	ret = usb_endpoint_manager_register_ep(&hc->ep_manager,
+	    USB_ADDRESS_DEFAULT, 0, USB_DIRECTION_BOTH, ep, endpoint_destroy, 0);
+	if (ret == EEXISTS) {
+		async_usleep(1000);
+		goto try_retgister;
+	}
+	if (ret != EOK) {
+		endpoint_destroy(ep);
+	}
+	return ret;
+#endif
+}
+/*----------------------------------------------------------------------------*/
+/** Release default address interface function
+ *
+ * @param[in] fun DDF function that was called.
+ * @return Error code.
+ */
+static int release_default_address(ddf_fun_t *fun)
+{
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_log_debug("Default address release.\n");
+//	return usb_endpoint_manager_unregister_ep(&hc->ep_manager,
+//	    USB_ADDRESS_DEFAULT, 0, USB_DIRECTION_BOTH);
+	usb_device_keeper_release_default_address(&hc->manager);
 	return EOK;
 }
@@ -140,6 +151,5 @@
 /*----------------------------------------------------------------------------*/
 static int register_endpoint(
-    ddf_fun_t *fun, usb_address_t address, usb_speed_t ep_speed,
-    usb_endpoint_t endpoint,
+    ddf_fun_t *fun, usb_address_t address, usb_endpoint_t endpoint,
     usb_transfer_type_t transfer_type, usb_direction_t direction,
     size_t max_packet_size, unsigned int interval)
@@ -147,15 +157,33 @@
 	hc_t *hc = fun_to_hc(fun);
 	assert(hc);
-	const size_t size = max_packet_size;
-	usb_speed_t speed = usb_device_keeper_get_speed(&hc->manager, address);
-	if (speed >= USB_SPEED_MAX) {
-		speed = ep_speed;
-	}
+	const usb_speed_t speed =
+	    usb_device_keeper_get_speed(&hc->manager, address);
+	const size_t size =
+	    (transfer_type == USB_TRANSFER_INTERRUPT
+	    || transfer_type == USB_TRANSFER_ISOCHRONOUS) ?
+	    max_packet_size : 0;
+	int ret;
+
+	endpoint_t *ep = malloc(sizeof(endpoint_t));
+	if (ep == NULL)
+		return ENOMEM;
+	ret = endpoint_init(ep, address, endpoint, direction,
+	    transfer_type, speed, max_packet_size);
+	if (ret != EOK) {
+		free(ep);
+		return ret;
+	}
+
 	usb_log_debug("Register endpoint %d:%d %s %s(%d) %zu(%zu) %u.\n",
 	    address, endpoint, usb_str_transfer_type(transfer_type),
 	    usb_str_speed(speed), direction, size, max_packet_size, interval);
 
-	return usb_endpoint_manager_add_ep(&hc->ep_manager, address, endpoint,
-	    direction, transfer_type, speed, max_packet_size, size);
+	ret = usb_endpoint_manager_register_ep(&hc->ep_manager, ep, size);
+	if (ret != EOK) {
+		endpoint_destroy(ep);
+	} else {
+		usb_device_keeper_add_ep(&hc->manager, address, ep);
+	}
+	return ret;
 }
 /*----------------------------------------------------------------------------*/
@@ -176,4 +204,5 @@
  * @param[in] fun DDF function that was called.
  * @param[in] target USB device to write to.
+ * @param[in] max_packet_size maximum size of data packet the device accepts
  * @param[in] data Source of data.
  * @param[in] size Size of data source.
@@ -183,17 +212,45 @@
  */
 static int interrupt_out(
-    ddf_fun_t *fun, usb_target_t target, void *data,
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size, void *data,
     size_t size, usbhc_iface_transfer_out_callback_t callback, void *arg)
 {
-	usb_transfer_batch_t *batch = NULL;
-	hc_t *hc = NULL;
-	int ret = setup_batch(fun, target, USB_DIRECTION_OUT, data, size,
-	    NULL, 0, NULL, callback, arg, "Interrupt OUT", &hc, &batch);
-	if (ret != EOK)
-		return ret;
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+
+	usb_log_debug("Interrupt OUT %d:%d %zu(%zu).\n",
+	    target.address, target.endpoint, size, max_packet_size);
+
+	size_t res_bw;
+	endpoint_t *ep = usb_endpoint_manager_get_ep(&hc->ep_manager,
+	    target.address, target.endpoint, USB_DIRECTION_OUT, &res_bw);
+	if (ep == NULL) {
+		usb_log_error("Endpoint(%d:%d) not registered for INT OUT.\n",
+			target.address, target.endpoint);
+		return ENOENT;
+	}
+	const size_t bw = bandwidth_count_usb11(ep->speed, ep->transfer_type,
+	    size, ep->max_packet_size);
+	if (res_bw < bw)
+	{
+		usb_log_error("Endpoint(%d:%d) INT IN needs %zu bw "
+		    "but only %zu is reserved.\n",
+		    target.address, target.endpoint, bw, res_bw);
+		return ENOENT;
+	}
+	assert(ep->speed ==
+	    usb_device_keeper_get_speed(&hc->manager, target.address));
+	assert(ep->max_packet_size == max_packet_size);
+	assert(ep->transfer_type == USB_TRANSFER_INTERRUPT);
+
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, ep->transfer_type, ep->max_packet_size,
+	        ep->speed, data, size, NULL, 0, NULL, callback, arg, ep);
+	if (!batch)
+		return ENOMEM;
 	batch_interrupt_out(batch);
-	ret = hc_schedule(hc, batch);
-	if (ret != EOK) {
-		usb_transfer_batch_dispose(batch);
+	const int ret = hc_schedule(hc, batch);
+	if (ret != EOK) {
+		batch_dispose(batch);
 	}
 	return ret;
@@ -204,4 +261,5 @@
  * @param[in] fun DDF function that was called.
  * @param[in] target USB device to write to.
+ * @param[in] max_packet_size maximum size of data packet the device accepts
  * @param[out] data Data destination.
  * @param[in] size Size of data source.
@@ -211,17 +269,46 @@
  */
 static int interrupt_in(
-    ddf_fun_t *fun, usb_target_t target, void *data,
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size, void *data,
     size_t size, usbhc_iface_transfer_in_callback_t callback, void *arg)
 {
-	usb_transfer_batch_t *batch = NULL;
-	hc_t *hc = NULL;
-	int ret = setup_batch(fun, target, USB_DIRECTION_IN, data, size,
-	    NULL, 0, callback, NULL, arg, "Interrupt IN", &hc, &batch);
-	if (ret != EOK)
-		return ret;
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+
+	usb_log_debug("Interrupt IN %d:%d %zu(%zu).\n",
+	    target.address, target.endpoint, size, max_packet_size);
+
+	size_t res_bw;
+	endpoint_t *ep = usb_endpoint_manager_get_ep(&hc->ep_manager,
+	    target.address, target.endpoint, USB_DIRECTION_IN, &res_bw);
+	if (ep == NULL) {
+		usb_log_error("Endpoint(%d:%d) not registered for INT IN.\n",
+		    target.address, target.endpoint);
+		return ENOENT;
+	}
+	const size_t bw = bandwidth_count_usb11(ep->speed, ep->transfer_type,
+	    size, ep->max_packet_size);
+	if (res_bw < bw)
+	{
+		usb_log_error("Endpoint(%d:%d) INT IN needs %zu bw "
+		    "but only %zu bw is reserved.\n",
+		    target.address, target.endpoint, bw, res_bw);
+		return ENOENT;
+	}
+
+	assert(ep->speed ==
+	    usb_device_keeper_get_speed(&hc->manager, target.address));
+	assert(ep->max_packet_size == max_packet_size);
+	assert(ep->transfer_type == USB_TRANSFER_INTERRUPT);
+
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, ep->transfer_type, ep->max_packet_size,
+	        ep->speed, data, size, NULL, 0, callback, NULL, arg, ep);
+	if (!batch)
+		return ENOMEM;
 	batch_interrupt_in(batch);
-	ret = hc_schedule(hc, batch);
-	if (ret != EOK) {
-		usb_transfer_batch_dispose(batch);
+	const int ret = hc_schedule(hc, batch);
+	if (ret != EOK) {
+		batch_dispose(batch);
 	}
 	return ret;
@@ -232,4 +319,5 @@
  * @param[in] fun DDF function that was called.
  * @param[in] target USB device to write to.
+ * @param[in] max_packet_size maximum size of data packet the device accepts
  * @param[in] data Source of data.
  * @param[in] size Size of data source.
@@ -239,17 +327,35 @@
  */
 static int bulk_out(
-    ddf_fun_t *fun, usb_target_t target, void *data,
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size, void *data,
     size_t size, usbhc_iface_transfer_out_callback_t callback, void *arg)
 {
-	usb_transfer_batch_t *batch = NULL;
-	hc_t *hc = NULL;
-	int ret = setup_batch(fun, target, USB_DIRECTION_OUT, data, size,
-	    NULL, 0, NULL, callback, arg, "Bulk OUT", &hc, &batch);
-	if (ret != EOK)
-		return ret;
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+
+	usb_log_debug("Bulk OUT %d:%d %zu(%zu).\n",
+	    target.address, target.endpoint, size, max_packet_size);
+
+	endpoint_t *ep = usb_endpoint_manager_get_ep(&hc->ep_manager,
+	    target.address, target.endpoint, USB_DIRECTION_OUT, NULL);
+	if (ep == NULL) {
+		usb_log_error("Endpoint(%d:%d) not registered for BULK OUT.\n",
+			target.address, target.endpoint);
+		return ENOENT;
+	}
+	assert(ep->speed ==
+	    usb_device_keeper_get_speed(&hc->manager, target.address));
+	assert(ep->max_packet_size == max_packet_size);
+	assert(ep->transfer_type == USB_TRANSFER_BULK);
+
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, ep->transfer_type, ep->max_packet_size,
+	        ep->speed, data, size, NULL, 0, NULL, callback, arg, ep);
+	if (!batch)
+		return ENOMEM;
 	batch_bulk_out(batch);
-	ret = hc_schedule(hc, batch);
-	if (ret != EOK) {
-		usb_transfer_batch_dispose(batch);
+	const int ret = hc_schedule(hc, batch);
+	if (ret != EOK) {
+		batch_dispose(batch);
 	}
 	return ret;
@@ -260,4 +366,5 @@
  * @param[in] fun DDF function that was called.
  * @param[in] target USB device to write to.
+ * @param[in] max_packet_size maximum size of data packet the device accepts
  * @param[out] data Data destination.
  * @param[in] size Size of data source.
@@ -267,17 +374,34 @@
  */
 static int bulk_in(
-    ddf_fun_t *fun, usb_target_t target, void *data,
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size, void *data,
     size_t size, usbhc_iface_transfer_in_callback_t callback, void *arg)
 {
-	usb_transfer_batch_t *batch = NULL;
-	hc_t *hc = NULL;
-	int ret = setup_batch(fun, target, USB_DIRECTION_IN, data, size,
-	    NULL, 0, callback, NULL, arg, "Bulk IN", &hc, &batch);
-	if (ret != EOK)
-		return ret;
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_log_debug("Bulk IN %d:%d %zu(%zu).\n",
+	    target.address, target.endpoint, size, max_packet_size);
+
+	endpoint_t *ep = usb_endpoint_manager_get_ep(&hc->ep_manager,
+	    target.address, target.endpoint, USB_DIRECTION_IN, NULL);
+	if (ep == NULL) {
+		usb_log_error("Endpoint(%d:%d) not registered for BULK IN.\n",
+			target.address, target.endpoint);
+		return ENOENT;
+	}
+	assert(ep->speed ==
+	    usb_device_keeper_get_speed(&hc->manager, target.address));
+	assert(ep->max_packet_size == max_packet_size);
+	assert(ep->transfer_type == USB_TRANSFER_BULK);
+
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, ep->transfer_type, ep->max_packet_size,
+	        ep->speed, data, size, NULL, 0, callback, NULL, arg, ep);
+	if (!batch)
+		return ENOMEM;
 	batch_bulk_in(batch);
-	ret = hc_schedule(hc, batch);
-	if (ret != EOK) {
-		usb_transfer_batch_dispose(batch);
+	const int ret = hc_schedule(hc, batch);
+	if (ret != EOK) {
+		batch_dispose(batch);
 	}
 	return ret;
@@ -288,4 +412,5 @@
  * @param[in] fun DDF function that was called.
  * @param[in] target USB device to write to.
+ * @param[in] max_packet_size maximum size of data packet the device accepts.
  * @param[in] setup_data Data to send with SETUP transfer.
  * @param[in] setup_size Size of data to send with SETUP transfer (always 8B).
@@ -297,20 +422,35 @@
  */
 static int control_write(
-    ddf_fun_t *fun, usb_target_t target,
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size,
     void *setup_data, size_t setup_size, void *data, size_t size,
     usbhc_iface_transfer_out_callback_t callback, void *arg)
 {
-	usb_transfer_batch_t *batch = NULL;
-	hc_t *hc = NULL;
-	int ret = setup_batch(fun, target, USB_DIRECTION_BOTH, data, size,
-	    setup_data, setup_size, NULL, callback, arg, "Control WRITE",
-	    &hc, &batch);
-	if (ret != EOK)
-		return ret;
-	usb_endpoint_manager_reset_if_need(&hc->ep_manager, target, setup_data);
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_speed_t speed =
+	    usb_device_keeper_get_speed(&hc->manager, target.address);
+	usb_log_debug("Control WRITE (%d) %d:%d %zu(%zu).\n",
+	    speed, target.address, target.endpoint, size, max_packet_size);
+	endpoint_t *ep = usb_endpoint_manager_get_ep(&hc->ep_manager,
+	    target.address, target.endpoint, USB_DIRECTION_BOTH, NULL);
+	if (ep == NULL) {
+		usb_log_warning("Endpoint(%d:%d) not registered for CONTROL.\n",
+			target.address, target.endpoint);
+	}
+
+	if (setup_size != 8)
+		return EINVAL;
+
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, USB_TRANSFER_CONTROL, max_packet_size, speed,
+	        data, size, setup_data, setup_size, NULL, callback, arg, ep);
+	if (!batch)
+		return ENOMEM;
+	usb_device_keeper_reset_if_need(&hc->manager, target, setup_data);
 	batch_control_write(batch);
-	ret = hc_schedule(hc, batch);
-	if (ret != EOK) {
-		usb_transfer_batch_dispose(batch);
+	const int ret = hc_schedule(hc, batch);
+	if (ret != EOK) {
+		batch_dispose(batch);
 	}
 	return ret;
@@ -321,4 +461,5 @@
  * @param[in] fun DDF function that was called.
  * @param[in] target USB device to write to.
+ * @param[in] max_packet_size maximum size of data packet the device accepts.
  * @param[in] setup_data Data to send with SETUP packet.
  * @param[in] setup_size Size of data to send with SETUP packet (should be 8B).
@@ -330,19 +471,31 @@
  */
 static int control_read(
-    ddf_fun_t *fun, usb_target_t target,
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size,
     void *setup_data, size_t setup_size, void *data, size_t size,
     usbhc_iface_transfer_in_callback_t callback, void *arg)
 {
-	usb_transfer_batch_t *batch = NULL;
-	hc_t *hc = NULL;
-	int ret = setup_batch(fun, target, USB_DIRECTION_BOTH, data, size,
-	    setup_data, setup_size, callback, NULL, arg, "Control READ",
-	    &hc, &batch);
-	if (ret != EOK)
-		return ret;
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_speed_t speed =
+	    usb_device_keeper_get_speed(&hc->manager, target.address);
+
+	usb_log_debug("Control READ(%d) %d:%d %zu(%zu).\n",
+	    speed, target.address, target.endpoint, size, max_packet_size);
+	endpoint_t *ep = usb_endpoint_manager_get_ep(&hc->ep_manager,
+	    target.address, target.endpoint, USB_DIRECTION_BOTH, NULL);
+	if (ep == NULL) {
+		usb_log_warning("Endpoint(%d:%d) not registered for CONTROL.\n",
+			target.address, target.endpoint);
+	}
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, USB_TRANSFER_CONTROL, max_packet_size, speed,
+	        data, size, setup_data, setup_size, callback, NULL, arg, ep);
+	if (!batch)
+		return ENOMEM;
 	batch_control_read(batch);
-	ret = hc_schedule(hc, batch);
-	if (ret != EOK) {
-		usb_transfer_batch_dispose(batch);
+	const int ret = hc_schedule(hc, batch);
+	if (ret != EOK) {
+		batch_dispose(batch);
 	}
 	return ret;
@@ -350,4 +503,6 @@
 /*----------------------------------------------------------------------------*/
 usbhc_iface_t hc_iface = {
+	.reserve_default_address = reserve_default_address,
+	.release_default_address = release_default_address,
 	.request_address = request_address,
 	.bind_address = bind_address,
Index: uspace/drv/uhci-hcd/main.c
===================================================================
--- uspace/drv/uhci-hcd/main.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/uhci-hcd/main.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -39,4 +39,5 @@
 #include <usb/debug.h>
 
+#include "iface.h"
 #include "uhci.h"
 
@@ -61,7 +62,6 @@
 int uhci_add_device(ddf_dev_t *device)
 {
-	usb_log_debug2("uhci_add_device() called\n");
+	usb_log_debug("uhci_add_device() called\n");
 	assert(device);
-
 	uhci_t *uhci = malloc(sizeof(uhci_t));
 	if (uhci == NULL) {
@@ -72,11 +72,11 @@
 	int ret = uhci_init(uhci, device);
 	if (ret != EOK) {
-		usb_log_error("Failed(%d) to initialize UHCI driver: %s.\n",
-		    ret, str_error(ret));
+		usb_log_error("Failed to initialize UHCI driver: %s.\n",
+		    str_error(ret));
 		return ret;
 	}
 	device->driver_data = uhci;
 
-	usb_log_info("Controlling new UHCI device '%s'.\n", device->name);
+	usb_log_info("Controlling new UHCI device `%s'.\n", device->name);
 
 	return EOK;
@@ -85,5 +85,5 @@
 /** Initialize global driver structures (NONE).
  *
- * @param[in] argc Number of arguments in argv vector (ignored).
+ * @param[in] argc Nmber of arguments in argv vector (ignored).
  * @param[in] argv Cmdline argument vector (ignored).
  * @return Error code.
@@ -94,4 +94,6 @@
 {
 	printf(NAME ": HelenOS UHCI driver.\n");
+
+	sleep(3); /* TODO: remove in final version */
 	usb_log_enable(USB_LOG_LEVEL_DEFAULT, NAME);
 
Index: uspace/drv/uhci-hcd/pci.c
===================================================================
--- uspace/drv/uhci-hcd/pci.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/uhci-hcd/pci.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -44,5 +44,5 @@
 #include "pci.h"
 
-/** Get I/O address of registers and IRQ for given device.
+/** Get address of registers and IRQ for given device.
  *
  * @param[in] dev Device asking for the addresses.
@@ -53,16 +53,18 @@
  */
 int pci_get_my_registers(ddf_dev_t *dev,
-    uintptr_t *io_reg_address, size_t *io_reg_size, int *irq_no)
+    uintptr_t *io_reg_address, size_t *io_reg_size,
+    int *irq_no)
 {
 	assert(dev != NULL);
 
-	int parent_phone =
-	    devman_parent_device_connect(dev->handle, IPC_FLAG_BLOCKING);
+	int parent_phone = devman_parent_device_connect(dev->handle,
+	    IPC_FLAG_BLOCKING);
 	if (parent_phone < 0) {
 		return parent_phone;
 	}
 
+	int rc;
 	hw_resource_list_t hw_resources;
-	int rc = hw_res_get_resource_list(parent_phone, &hw_resources);
+	rc = hw_res_get_resource_list(parent_phone, &hw_resources);
 	if (rc != EOK) {
 		goto leave;
@@ -93,5 +95,4 @@
 			    res->res.io_range.address, res->res.io_range.size);
 			io_found = true;
-			break;
 
 		default:
@@ -112,4 +113,5 @@
 leave:
 	async_hangup(parent_phone);
+
 	return rc;
 }
@@ -143,5 +145,5 @@
 	}
 
-	/* See UHCI design guide for these values p.45,
+	/* See UHCI design guide for these values,
 	 * write all WC bits in USB legacy register */
 	sysarg_t address = 0xc0;
Index: uspace/drv/uhci-hcd/root_hub.c
===================================================================
--- uspace/drv/uhci-hcd/root_hub.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/uhci-hcd/root_hub.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -55,13 +55,10 @@
 	int ret = asprintf(&match_str, "usb&uhci&root-hub");
 	if (ret < 0) {
-		usb_log_error(
-		    "Failed(%d) to create root hub match string: %s.\n",
-		    ret, str_error(ret));
-		return ret;
+		usb_log_error("Failed to create root hub match string.\n");
+		return ENOMEM;
 	}
 
 	ret = ddf_fun_add_match_id(fun, match_str, 100);
 	if (ret != EOK) {
-		free(match_str);
 		usb_log_error("Failed(%d) to add root hub match id: %s\n",
 		    ret, str_error(ret));
@@ -69,8 +66,8 @@
 	}
 
-	/* Initialize resource structure */
-	instance->resource_list.count = 1;
-	instance->resource_list.resources = &instance->io_regs;
-
+	hw_resource_list_t *resource_list = &instance->resource_list;
+	resource_list->count = 1;
+	resource_list->resources = &instance->io_regs;
+	assert(resource_list->resources);
 	instance->io_regs.type = IO_RANGE;
 	instance->io_regs.res.io_range.address = reg_addr;
Index: uspace/drv/uhci-hcd/root_hub.h
===================================================================
--- uspace/drv/uhci-hcd/root_hub.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/uhci-hcd/root_hub.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -39,9 +39,6 @@
 #include <ops/hw_res.h>
 
-/** DDF support structure for uhci-rhd driver, provides I/O resources */
 typedef struct rh {
-	/** List of resources available to the root hub. */
 	hw_resource_list_t resource_list;
-	/** The only resource in the above list */
 	hw_resource_t io_regs;
 } rh_t;
Index: uspace/drv/uhci-hcd/transfer_list.c
===================================================================
--- uspace/drv/uhci-hcd/transfer_list.c	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/uhci-hcd/transfer_list.c	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -57,7 +57,7 @@
 		return ENOMEM;
 	}
-	uint32_t queue_head_pa = addr_to_phys(instance->queue_head);
+	instance->queue_head_pa = addr_to_phys(instance->queue_head);
 	usb_log_debug2("Transfer list %s setup with QH: %p(%p).\n",
-	    name, instance->queue_head, queue_head_pa);
+	    name, instance->queue_head, instance->queue_head_pa);
 
 	qh_init(instance->queue_head);
@@ -67,15 +67,4 @@
 }
 /*----------------------------------------------------------------------------*/
-/** Dispose transfer list structures.
- *
- * @param[in] instance Memory place to use.
- *
- * Frees memory for internal qh_t structure.
- */
-void transfer_list_fini(transfer_list_t *instance)
-{
-	assert(instance);
-	free32(instance->queue_head);
-}
 /** Set the next list in transfer list chain.
  *
@@ -92,12 +81,13 @@
 	if (!instance->queue_head)
 		return;
-	/* Set queue_head.next to point to the follower */
-	qh_set_next_qh(instance->queue_head, next->queue_head);
-}
-/*----------------------------------------------------------------------------*/
-/** Add transfer batch to the list and queue.
+	/* Set both queue_head.next to point to the follower */
+	qh_set_next_qh(instance->queue_head, next->queue_head_pa);
+}
+/*----------------------------------------------------------------------------*/
+/** Submit transfer batch to the list and queue.
  *
  * @param[in] instance List to use.
  * @param[in] batch Transfer batch to submit.
+ * @return Error code
  *
  * The batch is added to the end of the list and queue.
@@ -119,6 +109,6 @@
 	} else {
 		/* There is something scheduled */
-		usb_transfer_batch_t *last =
-		    usb_transfer_batch_from_link(instance->batch_list.prev);
+		usb_transfer_batch_t *last = list_get_instance(
+		    instance->batch_list.prev, usb_transfer_batch_t, link);
 		last_qh = batch_qh(last);
 	}
@@ -128,5 +118,5 @@
 	/* keep link */
 	batch_qh(batch)->next = last_qh->next;
-	qh_set_next_qh(last_qh, batch_qh(batch));
+	qh_set_next_qh(last_qh, pa);
 
 	asm volatile ("": : :"memory");
@@ -142,8 +132,12 @@
 }
 /*----------------------------------------------------------------------------*/
-/** Add completed bantches to the provided list.
- *
- * @param[in] instance List to use.
- * @param[in] done list to fill
+/** Check list for finished batches.
+ *
+ * @param[in] instance List to use.
+ * @return Error code
+ *
+ * Creates a local list of finished batches and calls next_step on each and
+ * every one. This is safer because next_step may theoretically access
+ * this transfer list leading to the deadlock if its done inline.
  */
 void transfer_list_remove_finished(transfer_list_t *instance, link_t *done)
@@ -157,8 +151,8 @@
 		link_t *next = current->next;
 		usb_transfer_batch_t *batch =
-		    usb_transfer_batch_from_link(current);
+		    list_get_instance(current, usb_transfer_batch_t, link);
 
 		if (batch_is_complete(batch)) {
-			/* Save for processing */
+			/* Save for post-processing */
 			transfer_list_remove_batch(instance, batch);
 			list_append(current, done);
@@ -167,7 +161,8 @@
 	}
 	fibril_mutex_unlock(&instance->guard);
-}
-/*----------------------------------------------------------------------------*/
-/** Walk the list and finish all batches with EINTR.
+
+}
+/*----------------------------------------------------------------------------*/
+/** Walk the list and abort all batches.
  *
  * @param[in] instance List to use.
@@ -179,7 +174,7 @@
 		link_t *current = instance->batch_list.next;
 		usb_transfer_batch_t *batch =
-		    usb_transfer_batch_from_link(current);
+		    list_get_instance(current, usb_transfer_batch_t, link);
 		transfer_list_remove_batch(instance, batch);
-		usb_transfer_batch_finish_error(batch, EINTR);
+		usb_transfer_batch_finish(batch, EIO);
 	}
 	fibril_mutex_unlock(&instance->guard);
@@ -190,4 +185,5 @@
  * @param[in] instance List to use.
  * @param[in] batch Transfer batch to remove.
+ * @return Error code
  *
  * Does not lock the transfer list, caller is responsible for that.
@@ -206,24 +202,24 @@
 
 	const char *qpos = NULL;
-	qh_t *prev_qh = NULL;
 	/* Remove from the hardware queue */
 	if (instance->batch_list.next == &batch->link) {
 		/* I'm the first one here */
-		prev_qh = instance->queue_head;
+		assert((instance->queue_head->next & LINK_POINTER_ADDRESS_MASK)
+		    == addr_to_phys(batch_qh(batch)));
+		instance->queue_head->next = batch_qh(batch)->next;
 		qpos = "FIRST";
 	} else {
-		/* The thing before me is a batch too */
 		usb_transfer_batch_t *prev =
-		    usb_transfer_batch_from_link(batch->link.prev);
-		prev_qh = batch_qh(prev);
+		    list_get_instance(
+		        batch->link.prev, usb_transfer_batch_t, link);
+		assert((batch_qh(prev)->next & LINK_POINTER_ADDRESS_MASK)
+		    == addr_to_phys(batch_qh(batch)));
+		batch_qh(prev)->next = batch_qh(batch)->next;
 		qpos = "NOT FIRST";
 	}
-	assert((prev_qh->next & LINK_POINTER_ADDRESS_MASK)
-	    == addr_to_phys(batch_qh(batch)));
-	prev_qh->next = batch_qh(batch)->next;
 	asm volatile ("": : :"memory");
 	/* Remove from the batch list */
 	list_remove(&batch->link);
-	usb_log_debug("Batch(%p) removed (%s) from %s, next: %x.\n",
+	usb_log_debug("Batch(%p) removed (%s) from %s, next %x.\n",
 	    batch, qpos, instance->name, batch_qh(batch)->next);
 }
Index: uspace/drv/uhci-hcd/transfer_list.h
===================================================================
--- uspace/drv/uhci-hcd/transfer_list.h	(revision e50cd7f06f4f69de26916ce998bb262dbcd8bec0)
+++ uspace/drv/uhci-hcd/transfer_list.h	(revision ef354b6778a2049a1546b354af20cf92410bf74c)
@@ -39,26 +39,35 @@
 #include "batch.h"
 #include "hw_struct/queue_head.h"
+#include "utils/malloc32.h"
 
-/** Structure maintaining both hw queue and software list
- * of currently executed transfers
- */
 typedef struct transfer_list
 {
-	/** Guard against multiple add/remove races */
 	fibril_mutex_t guard;
-	/** UHCI hw structure represeting this queue */
 	qh_t *queue_head;
-	/** Assigned name, for nicer debug output */
+	uint32_t queue_head_pa;
 	const char *name;
-	/** List of all batches in this list */
 	link_t batch_list;
 } transfer_list_t;
 
-void transfer_list_fini(transfer_list_t *instance);
+/** Dispose transfer list structures.
+ *
+ * @param[in] instance Memory place to use.
+ *
+ * Frees memory for internal qh_t structure.
+ */
+static inline void transfer_list_fini(transfer_list_t *instance)
+{
+	assert(instance);
+	free32(instance->queue_head);
+}
+
 int transfer_list_init(transfer_list_t *instance, const char *name);
+
 void transfer_list_set_next(transfer_list_t *instance, transfer_list_t *next);
-void transfer_list_add_batch(
-    transfer_list_t *instance, usb_transfer_batch_t *batch);
+
+void transfer_list_add_batch(transfer_list_t *instance, usb_transfer_batch_t *batch);
+
 void transfer_list_remove_finished(transfer_list_t *instance, link_t *done);
+
 void transfer_list_abort_all(transfer_list_t *instance);
 #endif
